Throwable的子类Error类是享有错误的父类澳门皇冠官网app

代码在运营中发生的标题正是老大

java中把二种非常封装多少个类,当程序出现难题时候,就能够创立丰硕类对象何况抛出有关信息

 

十一分种类:

Throwable类是Java中持有错误或特其余父类

Throwable的子类Error类是具备错误的父类

Throwable的另叁个子类Exception类是负有极其的父类

在支付中,相对来讲,大家并不关怀错误,而更关注卓殊

老大和不当的界别(通俗解释):

极其:也就是一位脑仁疼了,吃药睡觉等展开对应的操作就能够痊愈,不修改代码管理掉那三个,程序还足以实行

荒谬:也即是一个人得了绝症,不也许治愈,必需修改代码,程序才足以奉行

于是能够那样敞亮:大家并不关心患了绝症的人,而会想办法去治愈得了小病的人

示例:‘

package demo;

public class Demo {
    public static void main(String[] args) {
        function1();
        function2();
    }
    public static void function1(){
        //异常
        int[] arr = {1,2};
        System.out.println(arr[3]);
        //输出:
        //Exception in thread "main" java.lang.ArrayIndexOutOfBoundsException: 3
        //at demo.Demo.function1(Demo.java:11)
        //at demo.Demo.main(Demo.java:5)
    }
    public static void function2(){
        //错误
        int[] arr = new int[666666666];
        System.out.println(arr);
        //输出:
        //Exception in thread "main" java.lang.OutOfMemoryError: Java heap space
        //at demo.Demo.function2(Demo.java:19)
        //at demo.Demo.main(Demo.java:6)
    }
}

 

设若那多少个被抛出了,前面包车型客车顺序都不会执行,由此要想方法解决那些标题

 

极度中的关键字throw:

写一段代码,存在空指针格外

package demo;

public class ExceptionDemo {
    public static void main(String[] args) {
        int [] arr = null;
        function(arr);
    }
    public static int function(int[] arr){
        int i = arr[arr.length-1];
        return i;
    }
}

加盟throw关键字,抛出十二分:

package demo;

public class ExceptionDemo {
    public static void main(String[] args) throws Exception {
        int [] arr = null;
        int i = function(arr);
        System.out.println(i);
    }
    public static int function(int[] arr) throws Exception{
        //如果方法中有异常,需要在方法上声明:throws Exception
        //抛出的类型和声明的异常类应当一致
        //main调用这个方法,也需要加入声明
        if(arr == null){
            //抛出异常,告诉调用者
            //手动抛出异常
            throw new Exception("传递数组不存在");
        }
        if(arr.length == 0){
            throw new Exception("传递的数组中没有元素");
        }
        int i = arr[arr.length-1];
        return i;
    }
}
/*
输出:
Exception in thread "main" java.lang.Exception: 传递数组不存在
at demo.ExceptionDemo.function(ExceptionDemo.java:16)
at demo.ExceptionDemo.main(ExceptionDemo.java:6)
*/

那边注意,若果是运营时拾壹分(RuntimeException),无需throws注脚 ,

再正是借使发生这种特别,那么必得改代码,不然代码无意义

 

try  catch方法丰富管理:

package demo;

public class ExceptionDemo {
    public static void main(String[] args) {
        int[] arr = null;
        try {
            int i = function(arr);
            System.out.println(i);
        } catch (NullPointerException ex) {
            System.out.println(ex);
        } catch (ArrayIndexOutOfBoundsException ex) {
            System.out.println(ex);
        }
        System.out.println("结束");
    }

    public static int function(int[] arr) throws NullPointerException, ArrayIndexOutOfBoundsException {
        if (arr == null) {
            // 手动抛出空指针异常
            throw new NullPointerException("数组不存在");
        }
        if (arr.length < 6) {
            // 手动抛出数组索引越界异常
            throw new ArrayIndexOutOfBoundsException("数组没有6索引");
        }
        return arr[6];
    }
}
/*
输出:
java.lang.NullPointerException: 数组不存在
结束
 */

此间发掘,即便前后相继有十三分,可是依然实行前面包车型的士代码,这便是特别处理

 

catch的顺序:

平级:

package demo;/*
 * catch处理的注意事项:
 *   有顺序
 *   当异常是平级的时候,即没有继承关系的时候,没有顺序限制 
 */
public class ExceptionDemo {
    public static void main(String[] args) {
        try {

        } catch (NullPointerException e) {

        } catch (ArrayIndexOutOfBoundsException e) {

        }
    }
}

有再三再四关系:

package demo;
//有继承关系:越高级的写在越靠后
public class ExceptionDemo {
    public static void main(String[] args) {
        try {

        } catch (NullPointerException ex) {

        } catch (RuntimeException ex) {

        } catch (Exception ex){

        }
    }
}

 

 

finally:

package demo;

//finally:必须执行
//是否有异常都会执行
public class ExceptionDemo {
    public static void main(String[] args) {
        try {
            function(1);
        } catch (Exception ex) {
            System.out.println(ex);
        } finally {
            System.out.println("代码必须执行");
        }
    }

    public static void function(int a) throws Exception {
        if (a == 0) {
            throw new Exception();
        }
        System.out.println(a);
    }
}
//无论传入什么,都会输出:代码必须执行

 

注意事项:

澳门皇冠官网app,1.父类的不二诀要假诺抛出特别,子类重写后能够不抛出至极,不过子类假若要抛出特别,那几个那么些的存在延续关系不可能超越父类的卓殊

 

自定义相当:

不经常候需求部分自定义的百般,这里做三个演示:

package demo;

public class FuShuException extends RuntimeException {
    public FuShuException(String string){
        super(string);
    }
    public FuShuException(){}
}

package demo;

//设置一个情景,计算两门成绩的平均数,不能为负数
//如果是一个负数,就抛出异常
public class ExceptionDeno {
    public static void main(String[] args) throws FuShuException {
        try {
            int i = function(10, 97);
            System.out.println(i);
        } catch (FuShuException ex) {
            ex.printStackTrace();
        }
    }

    public static int function(int a, int b) throws FuShuException {
        if (a < 0 || b < 0) {
            throw new FuShuException("成绩不为负");
        }
        int sum = a + b;
        return sum / 2;
    }
}

 

相关文章